<?php

/*
Plugin Name: Digg Digg
Version: 4.2
Plugin URI: http://www.mkyong.com/blog/digg-digg-wordpress-plugin
Author: Yong Mook Kim
Author URI: http://www.mkyong.com/
Description: All-in-One social vote buttons - Digg, Reddit, dDone, Yahoo Buzz, TweetMeme, Topsy, facebook share, facebook like, Polladium, StumbleUpon, Delicious, Sphinn, Post comments, Google Buzz, Designbump, Designfloat, Thewebblend and blogengage.

http://digg.com/tools/integrate
http://www.reddit.com/buttons/
http://www.reddit.com/upgradebuttons
http://in.buzz.yahoo.com/buttons
http://www.dzone.com/links/buttons.jsp
http://tweetmeme.com/about/retweet_button
http://help.tweetmeme.com/category/button/
http://www.fbshare.me/
http://wiki.developers.facebook.com/index.php/Facebook_Share
http://www.facebook.com/facebook-widgets/share.php
http://developers.facebook.com/docs/reference/plugins/like
http://www.polladium.com/poll-this_get_badge.php
http://www.stumbleupon.com/buttons/
http://delicious.com/help/tools
http://delicious.com/help/savebuttons
http://sphinn.com/widgets/
http://code.google.com/apis/buzz/
http://buzrr.com/buttonselect.php?lang=en
http://thewebblend.com/tools/vote
http://www.designfloat.com/tools-en.php
http://designbump.com/content/evb
http://developerwiki.myspace.com/index.php?title=How_to_Add_Post_To_MySpace_to_Your_Site
http://www.google.com/buzz/api/admin/configPostWidget
http://www.blogengage.com/profile_promo.php
http://labs.topsy.com/button/retweet-button/

http://www.preloaders.net/
http://ajaxload.info/
*/ 
/*
ini_set('display_errors',1);
error_reporting(E_ALL);
*/
//include required class
require_once 'dd.class.php';
require_once 'dd.constant.php';
require_once 'dd.printform.php';
require_once 'dd.helper.php';

add_action('wp_head', 'digg_digg_stylesheet');
add_action('wp_head', 'digg_digg_ajax_float');
add_action('wp_head', 'digg_digg_head_script');

add_action('init', 'digg_digg_init');

add_filter('the_content', 'digg_digg_content_hook');

//plugin initial during activation, reset all value
register_activation_hook( __FILE__, 'digg_digg_initialIt');

//enable the jQuery library in Wordpress
function digg_digg_init() {
	
	//load the wordpress jquery build-in library (if it is not a admin page)
	if (!is_admin()) {
		wp_enqueue_script('jquery');
	}
}

//add digg digg CSS style
function digg_digg_stylesheet()
{
	echo '<link rel="stylesheet" href="' .DD_PLUGIN_URL . 'css/diggdigg-style.css?ver=' . DD_VERSION . '" type="text/css" media="screen" />';
}

//ajax left float settins
function digg_digg_ajax_float()
{
	if(get_option(DD_AJAX_LEFT_FLOAT_OPTION)==DD_DISPLAY_ON && (is_single() || is_page())){
		
		echo '<style type="text/css" media="screen">' . get_option(DD_AJAX_INITIAL_POSITION) . '</style>';
		echo '<script type="text/javascript">' . get_option(DD_AJAX_SCROLLING_POSITION) . '</script>';
	}	
}

//Digg Digg javascript in head
function digg_digg_head_script()
{
	//get the display buttons
	$dd_display_temp_buttons = get_option(DD_DISPLAY_BUTTON);
	
	if($dd_display_temp_buttons!=DD_EMPTY_VALUE){
		
		//Topsy required this script to go your pages <head> section
		foreach($dd_display_temp_buttons as $obj){
			if($obj->name=="Topsy"){
				echo "<script type=\"text/javascript\" src=\"http://cdn.topsy.com/topsy.js?init=topsyWidgetCreator\"></script>";	
			}
		}
	}
	
}

//reset all the value
function digg_digg_resetIt(){
	digg_digg_DataInitialer(DD_FUNC_TYPE_RESET);
}

//initial the value
function digg_digg_initialIt(){
	digg_digg_DataInitialer();
}

/*************** Digg Digg Admin menu ***************/
add_action('admin_init', 'digg_digg_admin_init');
add_action('admin_menu', 'digg_digg_admin_menu');

//admin page
function digg_digg_admin_init() {
	wp_register_style('dd_admin_style', DD_PLUGIN_URL . 'css/diggdigg-style-admin.css');
}

function digg_digg_admin_menu() {
	$page = add_submenu_page('options-general.php', 'Digg Digg Options', DD_NAME, 8, basename(__FILE__), 'digg_digg_menu');
	
    /* Using registered $page handle to hook stylesheet loading */
    add_action('admin_print_styles-' . $page, 'digg_digg_admin_styles');
}

function digg_digg_admin_styles(){
	wp_enqueue_style('dd_admin_style');
}
/*************** Digg Digg Admin menu ***************/

function digg_digg_menu(){
	
	$dd_digg = new DD_Digg();
	$dd_reddit = new DD_Reddit();
	$dd_dzone = new DD_Dzone();
	$dd_ybuzz = new DD_YBuzz();
	$dd_twitter = new DD_Twitter();
	$dd_topsy = new DD_Topsy();
	$dd_fbshare = new DD_FbShare();
	$dd_fbshareme = new DD_FbShareMe();
	$dd_fblike = new DD_FbLike();
	$dd_polladium = new DD_Polladium();
	$dd_stumbleupon = new DD_StumbleUpon();
	$dd_delicious = new DD_Delicious();
	$dd_sphinn = new DD_Sphinn();
	$dd_comments = new DD_Comments();
	$dd_gbuzz = new DD_GBuzz();
	$dd_designbump = new DD_DesignBump();
	$dd_designfloat = new DD_DesignFloat();
	$dd_webblend = new DD_WebBlend();
	$dd_blogengage = new DD_BlogEngage();
	
	if (isset($_POST[DD_FORM_SAVE])) {

	    //digg.com
	    foreach(array_keys($dd_digg->wp_options) as $key){
	    	if(isset($_POST[$key])){
	    		$dd_digg->wp_options[$key] = $_POST[$key];
	    	}else{
	    		$dd_digg->wp_options[$key] = DD_EMPTY_VALUE;
	    	}
	    }
		    
	    //reddit.com
	    foreach(array_keys($dd_reddit->wp_options) as $key){
	    	if(isset($_POST[$key])){
	    		$dd_reddit->wp_options[$key] = $_POST[$key];
	    	}else{
	    		$dd_reddit->wp_options[$key] = DD_EMPTY_VALUE;
	    	}
	    }

	    //dzone.com
		foreach(array_keys($dd_dzone->wp_options) as $key){
			if(isset($_POST[$key])){
	    		$dd_dzone->wp_options[$key] = $_POST[$key];
			}else{
				$dd_dzone->wp_options[$key] = DD_EMPTY_VALUE;
			}
	    }
	    
	    //yahoo buzz
		foreach(array_keys($dd_ybuzz->wp_options) as $key){
			if(isset($_POST[$key])){
	    		$dd_ybuzz->wp_options[$key] = $_POST[$key];
			}else{
				$dd_ybuzz->wp_options[$key] = DD_EMPTY_VALUE;
			}
	    }
	    
		//twitter
		foreach(array_keys($dd_twitter->wp_options) as $key){
			if(isset($_POST[$key])){
	    		$dd_twitter->wp_options[$key] = $_POST[$key];
			}else{
				$dd_twitter->wp_options[$key] = DD_EMPTY_VALUE;
			}
	    }
	    
	    //topsy
		foreach(array_keys($dd_topsy->wp_options) as $key){
			if(isset($_POST[$key])){
	    		$dd_topsy->wp_options[$key] = $_POST[$key];
			}else{
				$dd_topsy->wp_options[$key] = DD_EMPTY_VALUE;
			}
	    }
	    
	    //fbshare.me
		foreach(array_keys($dd_fbshareme->wp_options) as $key){
			if(isset($_POST[$key])){
	    		$dd_fbshareme->wp_options[$key] = $_POST[$key];
			}else{
				$dd_fbshareme->wp_options[$key] = DD_EMPTY_VALUE;
			}
	    }
	    
		//facebook
		foreach(array_keys($dd_fbshare->wp_options) as $key){
			if(isset($_POST[$key])){
	    		$dd_fbshare->wp_options[$key] = $_POST[$key];
			}else{
				$dd_fbshare->wp_options[$key] = DD_EMPTY_VALUE;
			}
	    }
	    
	    //facebook like
	    foreach(array_keys($dd_fblike->wp_options) as $key){
	    	if(isset($_POST[$key])){
	    		$dd_fblike->wp_options[$key] = $_POST[$key];
	    	}else{
	    		$dd_fblike->wp_options[$key] = DD_EMPTY_VALUE;
	    	}
	    }
	    
		//polladium
		foreach(array_keys($dd_polladium->wp_options) as $key){
			if(isset($_POST[$key])){
	    		$dd_polladium->wp_options[$key] = $_POST[$key];
			}else{
				$dd_polladium->wp_options[$key] = DD_EMPTY_VALUE;
			}
	    }
	
	    //stumbleupon
	    foreach(array_keys($dd_stumbleupon->wp_options) as $key){
	    	if(isset($_POST[$key])){
	    		$dd_stumbleupon->wp_options[$key] = $_POST[$key];
	    	}else{
	    		$dd_stumbleupon->wp_options[$key] = DD_EMPTY_VALUE;
	    	}
	    }
	    
		//delicious
	    foreach(array_keys($dd_delicious->wp_options) as $key){
	    	if(isset($_POST[$key])){
	    		$dd_delicious->wp_options[$key] = $_POST[$key];
	    	}else{
	    		$dd_delicious->wp_options[$key] = DD_EMPTY_VALUE;
	    	}
	    }
	    
		//sphinn
	    foreach(array_keys($dd_sphinn->wp_options) as $key){
	    	if(isset($_POST[$key])){
	    		$dd_sphinn->wp_options[$key] = $_POST[$key];
	    	}else{
	    		$dd_sphinn->wp_options[$key] = DD_EMPTY_VALUE;
	    	}
	    }
	    
		//post comments
	    foreach(array_keys($dd_comments->wp_options) as $key){
	    	if(isset($_POST[$key])){
	    		$dd_comments->wp_options[$key] = $_POST[$key];
	    	}else{
	    		$dd_comments->wp_options[$key] = DD_EMPTY_VALUE;
	    	}
	    }
	    
		//Google Buzz
	    foreach(array_keys($dd_gbuzz->wp_options) as $key){
	    	if(isset($_POST[$key])){
	    		$dd_gbuzz->wp_options[$key] = $_POST[$key];
	    	}else{
	    		$dd_gbuzz->wp_options[$key] = DD_EMPTY_VALUE;
	    	}
	    }
	    
		//Designbump
	    foreach(array_keys($dd_designbump->wp_options) as $key){
	    	if(isset($_POST[$key])){
	    		$dd_designbump->wp_options[$key] = $_POST[$key];
	    	}else{
	    		$dd_designbump->wp_options[$key] = DD_EMPTY_VALUE;
	    	}
	    }
	    
		//Designfloat 
	    foreach(array_keys($dd_designfloat->wp_options) as $key){
	    	if(isset($_POST[$key])){
	    		$dd_designfloat->wp_options[$key] = $_POST[$key];
	    	}else{
	    		$dd_designfloat->wp_options[$key] = DD_EMPTY_VALUE;
	    	}
	    }
	    
		//TheWebBlend 
	    foreach(array_keys($dd_webblend->wp_options) as $key){
	    	if(isset($_POST[$key])){
	    		$dd_webblend->wp_options[$key] = $_POST[$key];
	    	}else{
	    		$dd_webblend->wp_options[$key] = DD_EMPTY_VALUE;
	    	}
	    }
	    
	    //BlogEngage
	    foreach(array_keys($dd_blogengage->wp_options) as $key){
	    	if(isset($_POST[$key])){
	    		$dd_blogengage->wp_options[$key] = $_POST[$key];
	    	}else{
	    		$dd_blogengage->wp_options[$key] = DD_EMPTY_VALUE;
	    	}
	    }
	    
		update_option(DD_DIGG_OPTIONS, $dd_digg->wp_options);
		update_option(DD_REDDIT_OPTIONS, $dd_reddit->wp_options);
		update_option(DD_DZONE_OPTIONS, $dd_dzone->wp_options);
		update_option(DD_YBUZZ_OPTIONS, $dd_ybuzz->wp_options);
		update_option(DD_TWITTER_OPTIONS, $dd_twitter->wp_options);
		update_option(DD_TOPSY_OPTIONS, $dd_topsy->wp_options);
		update_option(DD_FBSHARE_OPTIONS, $dd_fbshare->wp_options);
		update_option(DD_FBSHAREME_OPTIONS, $dd_fbshareme->wp_options);
		update_option(DD_FBLIKE_OPTIONS, $dd_fblike->wp_options);
		update_option(DD_POLLADIUM_OPTIONS, $dd_polladium->wp_options);
		update_option(DD_STUMBLEUPON_OPTIONS, $dd_stumbleupon->wp_options);
		update_option(DD_DELICIOUS_OPTIONS, $dd_delicious->wp_options);
		update_option(DD_SPHINN_OPTIONS, $dd_sphinn->wp_options);
		update_option(DD_COMMENTS_OPTIONS, $dd_comments->wp_options);
		update_option(DD_GBUZZ_OPTIONS, $dd_gbuzz->wp_options);
		update_option(DD_DESIGNDUMP_OPTIONS, $dd_designbump->wp_options);
		update_option(DD_DESIGNFLOAT_OPTIONS, $dd_designfloat->wp_options);
		update_option(DD_WEBBLEND_OPTIONS, $dd_webblend->wp_options);
		update_option(DD_BLOGENGAGE_OPTIONS, $dd_blogengage->wp_options);
		
		//normal buttons
		if(isset($_POST[DD_DISPLAY_HOME])){
			update_option(DD_DISPLAY_HOME, $_POST[DD_DISPLAY_HOME]);
		}else{
			update_option(DD_DISPLAY_HOME, DD_EMPTY_VALUE);
		}
		
		if(isset($_POST[DD_DISPLAY_PAGE])){
			update_option(DD_DISPLAY_PAGE, $_POST[DD_DISPLAY_PAGE]);
		}else{
			update_option(DD_DISPLAY_PAGE, DD_EMPTY_VALUE);
		}
		
		if(isset($_POST[DD_DISPLAY_POST])){
			update_option(DD_DISPLAY_POST, $_POST[DD_DISPLAY_POST]);
		}else{
			update_option(DD_DISPLAY_POST, DD_EMPTY_VALUE);
		}
	  
		if(isset($_POST[DD_DISPLAY_CATEGORY])){
			update_option(DD_DISPLAY_CATEGORY, $_POST[DD_DISPLAY_CATEGORY]);
		}else{
			update_option(DD_DISPLAY_CATEGORY, DD_EMPTY_VALUE);
		}
		
		if(isset($_POST[DD_DISPLAY_ARCHIVE])){
			update_option(DD_DISPLAY_ARCHIVE, $_POST[DD_DISPLAY_ARCHIVE]);
		}else{
			update_option(DD_DISPLAY_ARCHIVE, DD_EMPTY_VALUE);
		}
	
		//others
		if(isset($_POST[DD_DISABLED_CREDIT_LINK])){
			update_option(DD_DISABLED_CREDIT_LINK, $_POST[DD_DISABLED_CREDIT_LINK]);
		}else{
			update_option(DD_DISABLED_CREDIT_LINK, DD_EMPTY_VALUE);
		}
		
		if(isset($_POST[DD_AJAX_LEFT_FLOAT_OPTION])){
			update_option(DD_AJAX_LEFT_FLOAT_OPTION, $_POST[DD_AJAX_LEFT_FLOAT_OPTION]);
		}else{
			update_option(DD_AJAX_LEFT_FLOAT_OPTION, DD_EMPTY_VALUE);
		}
		
		update_option(DD_AJAX_INITIAL_POSITION, dd_filter_weird_characters($_POST[DD_AJAX_INITIAL_POSITION]));
		update_option(DD_AJAX_SCROLLING_POSITION, dd_filter_weird_characters($_POST[DD_AJAX_SCROLLING_POSITION]));
	
		//update line up option
		update_option(DD_LINE_UP, $_POST[DD_LINE_UP]);
			
		//update twitter source
		update_option(DD_TWITTER_SOURCE, $_POST[DD_TWITTER_SOURCE]);
		update_option(DD_TWITTER_SERVICE, $_POST[DD_TWITTER_SERVICE]);
		update_option(DD_TWITTER_SERVICE_API, $_POST[DD_TWITTER_SERVICE_API]);
		
		//update topsy source
		update_option(DD_TOPSY_SOURCE, $_POST[DD_TOPSY_SOURCE]);
		update_option(DD_TOPSY_THEME, $_POST[DD_TOPSY_THEME]);
		
		//update category name
		update_option(DD_CATEGORY_ALLOW, $_POST[DD_CATEGORY_ALLOW]);
		
		//Put all into array
		$dd_buttons = array($dd_digg,$dd_reddit,$dd_dzone,$dd_ybuzz,$dd_twitter,$dd_topsy,
		$dd_fbshare,$dd_fbshareme,$dd_fblike,$dd_polladium,$dd_stumbleupon,$dd_delicious,$dd_sphinn,
		$dd_comments,$dd_gbuzz,$dd_designbump,$dd_designfloat,$dd_webblend,$dd_blogengage);
		
		//Get what display only, to increase performance
		$dd_display_buttons = array();
		foreach($dd_buttons as $obj){
	    	if( ($obj->get_append_type()!=DD_SELECT_NONE) || ($obj->get_ajax_left_float()!=DD_DISPLAY_OFF) ){
				$dd_display_buttons[$obj->name] = $obj;
	    	}
	    }
		update_option(DD_DISPLAY_BUTTON, $dd_display_buttons);
		
		echo '<div id="message" class="updated fade"><p>Updated.</p></div>';
		
  	}else if(isset($_POST[DD_FORM_CLEAR])){
	
        digg_digg_resetIt();
		echo "<div id='message' class='error fade'><p>Settings Cleared.</p></div>";
			
  	}

  	//load options from db
  	$dd_digg->wp_options = get_option(DD_DIGG_OPTIONS);
  	$dd_reddit->wp_options = get_option(DD_REDDIT_OPTIONS);
  	$dd_dzone->wp_options = get_option(DD_DZONE_OPTIONS);
  	$dd_ybuzz->wp_options = get_option(DD_YBUZZ_OPTIONS);
  	$dd_twitter->wp_options = get_option(DD_TWITTER_OPTIONS);
  	$dd_topsy->wp_options = get_option(DD_TOPSY_OPTIONS);
  	$dd_fbshareme->wp_options = get_option(DD_FBSHAREME_OPTIONS);
  	$dd_fbshare->wp_options = get_option(DD_FBSHARE_OPTIONS);
  	$dd_fblike->wp_options = get_option(DD_FBLIKE_OPTIONS);
  	$dd_polladium->wp_options = get_option(DD_POLLADIUM_OPTIONS);
    $dd_stumbleupon->wp_options = get_option(DD_STUMBLEUPON_OPTIONS);
  	$dd_delicious->wp_options = get_option(DD_DELICIOUS_OPTIONS);
  	$dd_sphinn->wp_options = get_option(DD_SPHINN_OPTIONS);
  	$dd_comments->wp_options = get_option(DD_COMMENTS_OPTIONS);
  	$dd_gbuzz->wp_options = get_option(DD_GBUZZ_OPTIONS);
  	$dd_designbump->wp_options = get_option(DD_DESIGNDUMP_OPTIONS);
  	$dd_designfloat->wp_options = get_option(DD_DESIGNFLOAT_OPTIONS);
  	$dd_webblend->wp_options = get_option(DD_WEBBLEND_OPTIONS);
  	$dd_blogengage->wp_options = get_option(DD_BLOGENGAGE_OPTIONS);
  	
  	$dd_buttons = array($dd_digg,$dd_reddit,$dd_dzone,$dd_ybuzz,$dd_twitter,$dd_topsy,$dd_fbshareme,$dd_fbshare,$dd_fblike,$dd_polladium,$dd_stumbleupon,$dd_delicious,$dd_sphinn,$dd_comments,$dd_gbuzz,$dd_designbump,$dd_designfloat,$dd_webblend,$dd_blogengage);
  	
  	//sort it
	$dd_sorting_data = array();
	foreach($dd_buttons as $obj){
		$dd_sorting_data[$obj->get_button_weight().'-'.$obj->name] = $obj;
	}	
	krsort($dd_sorting_data,SORT_NUMERIC);
		
  	// display admin screen
  	print_digg_digg_menu_form($dd_sorting_data);
}

//hoooookkkkk it
function digg_digg_content_hook($content = ''){

    global $wp_query;
    $post = $wp_query->post; //get post content
    $id = $post->ID; //get post id
    $comments = $post->comment_count; //get post comments
    $postlink = get_permalink($id); //get post link
    $title = trim(urlencode($post->post_title)); // get post title
    $link = split(DD_DASH,$postlink); //split the link with '#', for comment
 
    $dd_category_allow = get_option(DD_CATEGORY_ALLOW);
    
    //allow to display?
    if(digg_digg_isDisplay()==false || digg_digg_isDisplayDisabled($content)==true || digg_digg_isCategoryAllow($dd_category_allow)==false){
    	return $content;
    }
   
    $dd_line_up = get_option(DD_LINE_UP);	 
    
	//get the display buttons
	$dd_display_buttons = get_option(DD_DISPLAY_BUTTON);
	
	if($dd_display_buttons!=DD_EMPTY_VALUE){
		
		//construts the finalURL
		foreach($dd_display_buttons as $obj){
			if(($obj->name=="TweetMeme" || $obj->name=="Twitter")){
				$dd_twitter_source = get_option(DD_TWITTER_SOURCE);
				$dd_twitter_service = get_option(DD_TWITTER_SERVICE);
				$dd_twitter_servicesapi = get_option(DD_TWITTER_SERVICE_API);
				$obj->construstURL($link[0],$dd_twitter_source,$obj->get_button_design(),$id,$dd_twitter_service, $dd_twitter_servicesapi);
			}else if($obj->name=="Topsy"){
				$dd_topsy_source = get_option(DD_TOPSY_SOURCE);
				$dd_topsy_theme = get_option(DD_TOPSY_THEME);
				$obj->construstURL($link[0],$obj->get_button_design(),$dd_topsy_source,$dd_topsy_theme);
			}else if($obj->name=="Comments"){
				$obj->construstURL($link[0],$comments);
			}else{
				$obj->construstURL($link[0],$title,$obj->get_button_design(),$id);
			}
		}
		
		//sort it
		$dd_sorting_data = array();
		foreach($dd_display_buttons as $obj){
			$dd_sorting_data[$obj->get_button_weight().'-'.$obj->name] = $obj;
		}
		
		krsort($dd_sorting_data,SORT_NUMERIC);
		
		$content = generateDiggDiggDiv($content,$dd_sorting_data, $dd_line_up);
		
		//generate ajax floating on left, only display in post page
		//add allow display checing here
		if((is_single() || is_page())&& (get_option(DD_AJAX_LEFT_FLOAT_OPTION)==DD_DISPLAY_ON)){
			$content = generateAjaxFloatDiv($content,$dd_sorting_data);
		}
	}

    return $content;
}

function generateAjaxFloatDiv($content,$dd_all_data){
	
	$result=DD_EMPTY_VALUE;
	
	$dd_jQuery_script ='';
	$dd_scheduler_script ='';
	
	foreach($dd_all_data as $obj){

		if($obj->get_ajax_left_float() == DD_DISPLAY_ON){
			
			$finalURL='';

			if($obj->get_lazy_load()==DD_EMPTY_VALUE){
				$finalURL=$obj->finalURL;
			}else{
				$finalURL=$obj->finalURL_lazy;
				$dd_jQuery_script.=$obj->finalURL_lazy_script;
				$dd_scheduler_script.=$obj->final_scheduler_lazy_script;
			}
			
			$result .= "<div class='dd_button_v'>" . $finalURL . "</div><div style='clear:left'></div>" ;	
		}
			
	}
	
	if($result != DD_EMPTY_VALUE){
		
		//disable the digg digg credit link?
		if(get_option(DD_DISABLED_CREDIT_LINK)==DD_DISPLAY_ON){
			$result = "<div class='dd_ajax_float'>" . $result . "</div>";
		}else{
			$result = "<div class='dd_ajax_float'>" . $result . "<div id='dd_name'><a href='http://www.mkyong.com/blog/digg-digg-wordpress-plugin/' target='_blank'>Digg Digg</a></div></div>";
		}
		
		//Lazy loading
		if($dd_jQuery_script!=''){
			$dd_jQuery_script = "<script type=\"text/javascript\">" . $dd_jQuery_script . "</script>";
		}
	
		$scheduler = '';
		if($dd_scheduler_script!=''){
			$scheduler = "<script type=\"text/javascript\">jQuery(document).ready(function($) { " . $dd_scheduler_script . " });</script>";
		}
		
		//when scrollbar beyond this y value, the ajax scroll effect started.
		$content = $scheduler . $dd_jQuery_script . $result . "<div class='dd_content_wrap'>" . $content . "</div>";
		
	}
	
	return $content;
}

function generateDiggDiggDiv($content,$dd_all_data, $dd_line_up){
	
	$dd_before_content = '';
	$dd_after_content = ''; 
	$dd_left_float = ''; 
	$dd_right_float = '';
	
	$dd_jQuery_script ='';
	$dd_scheduler_script ='';
	
	foreach($dd_all_data as $obj){
		
		$finalURL='';
		$name=$obj->name;
		
		if($obj->get_lazy_load()==DD_EMPTY_VALUE){
			$finalURL=$obj->finalURL;
		}else{
			$finalURL=$obj->finalURL_lazy;
			$dd_jQuery_script.=$obj->finalURL_lazy_script;
			$dd_scheduler_script.=$obj->final_scheduler_lazy_script;
		}
		
		if($obj->get_append_type() == DD_SELECT_LEFT_FLOAT){
			$dd_left_float .= generateDiv($finalURL,$dd_line_up,$name);
		}else if($obj->get_append_type() == DD_SELECT_RIGHT_FLOAT){
			$dd_right_float .= generateDiv($finalURL,$dd_line_up,$name);
		}else if($obj->get_append_type() == DD_SELECT_BEFORE_CONTENT){
			$dd_before_content .= generateDiv($finalURL,$dd_line_up,$name);
		}else if($obj->get_append_type() == DD_SELECT_AFTER_CONTENT){
			$dd_after_content .= generateDiv($finalURL,$dd_line_up,$name);
		}
			
	}
	
	if($dd_before_content!=''){
		$dd_before_content = "<div class='dd_post_share'><div class='dd_buttons'>" . $dd_before_content. "</div></div><div style='clear:both'></div>";	
	}
		
	if($dd_after_content!=''){
		$dd_after_content = "<div class='dd_post_share'><div class='dd_buttons'>" . $dd_after_content. "</div></div><div style='clear:both'></div>";	
	}
	
	if($dd_left_float!=''){
		$dd_left_float = "<div class='dd_post_share dd_post_share_left'><div class='dd_buttons'>" . $dd_left_float. "</div></div>";	
	}
		
	if($dd_right_float!=''){
		$dd_right_float = "<div class='dd_post_share dd_post_share_right'><div class='dd_buttons'>" . $dd_right_float. "</div></div>";	
	}	
	
	if($dd_jQuery_script!=''){
		$dd_jQuery_script = "<script type=\"text/javascript\">" . $dd_jQuery_script . "</script>";
	}

	$scheduler = '';
	if($dd_scheduler_script!=''){
		$scheduler = "<script type=\"text/javascript\">jQuery(document).ready(function($) { " . $dd_scheduler_script . " });</script>";
	}
	
	$content = $scheduler . $dd_jQuery_script . $dd_left_float . $dd_right_float . $dd_before_content . $content . $dd_after_content . DD_AUTHOR_SITE;
	
	return $content;
}

function generateDiv($link, $dd_line_up,$name){
	
	if($dd_line_up==DD_LINE_UP_HORIZONTAL){
		return "<div class='dd_button'>" .$link. "</div>" ;
	}else if($dd_line_up==DD_LINE_UP_VERTICAL){
		
		if ($name=="Facebook") {
			return "<div class='dd_button_v'>" .$link. "</div><div style='clear:left'></div>" ;		
		}
		else{
			return "<div class='dd_button_v'>" .$link. "</div>" ;
		}
		
	}else{
		return "<div class='dd_button'>" .$link. "</div>" ;
	}
	
}

/***********************************Advance Usage*********************************/

/**
 * Generate Digg button link
 * @param $buttonDesign Normal or Compact
 * @return Digg button link
 */
function digg_digg_generate($buttonDesign='Normal'){
	
	global $wp_query; 
    $post = $wp_query->post; //get post content
    $id = $post->ID; //get post id
    $postlink = get_permalink($id); //get post link
    $title = trim(urlencode($post->post_title)); // get post title
    $link = split(DD_DASH,$postlink); //split the link with '#', for comment
    
    $dd_digg = new DD_Digg();
    $dd_digg->construstURL($link[0],$title,$buttonDesign,$id);
    
	echo $dd_digg->finalURL;
}	

/**
 * Generate Reddit button link
 * @param $buttonDesign Normal or Compact
 * @return Reddit button link
 */
function digg_digg_reddit_generate($buttonDesign='Normal'){
	
	global $wp_query; 
    $post = $wp_query->post; //get post content
    $id = $post->ID; //get post id
    $postlink = get_permalink($id); //get post link
    $title = trim(urlencode($post->post_title)); // get post title
    $link = split(DD_DASH,$postlink); //split the link with '#', for comment
    
    $dd_reddit = new DD_Reddit();
    $dd_reddit->construstURL($link[0],$title,$buttonDesign,$id);
    
	echo $dd_reddit->finalURL;
}

/**
 * Generate Dzone button link
 * @param $buttonDesign Normal or Compact
 * @return Dzone button link
 */
function digg_digg_dzone_generate($buttonDesign='Normal'){
	
	global $wp_query; 
    $post = $wp_query->post; //get post content
    $id = $post->ID; //get post id
    $postlink = get_permalink($id); //get post link
    $title = trim(urlencode($post->post_title)); // get post title
    $link = split(DD_DASH,$postlink); //split the link with '#', for comment
    
    $dd_dzone = new DD_Dzone();
    $dd_dzone->construstURL($link[0],$title,$buttonDesign,$id);
    
	echo $dd_dzone->finalURL;
}

/**
 * Generate YBuzz button link
 * @param $buttonDesign Normal or Compact
 * @return YBuzz button link
 */
function digg_digg_ybuzz_generate($buttonDesign='Normal'){
	
	global $wp_query; 
    $post = $wp_query->post; //get post content
    $id = $post->ID; //get post id
    $postlink = get_permalink($id); //get post link
    $title = trim(urlencode($post->post_title)); // get post title
    $link = split(DD_DASH,$postlink); //split the link with '#', for comment
    
    $dd_ybuzz = new DD_YBuzz();
    $dd_ybuzz->construstURL($link[0],$title,$buttonDesign,$id);
    
	echo $dd_ybuzz->finalURL;
}

/**
 * Generate Twitter button link
 * @param $buttonDesign Normal or Compact
 * @param $source tweetmeme source, username
 * @param $service URL shorten service, e.g bit.ly
 * @param $serviceapi API Key for URL shorten service
 * @return Twitter button link
 */
function digg_digg_twitter_generate($buttonDesign='Normal', $source='', $service='',$serviceapi=''){
	
	global $wp_query; 
    $post = $wp_query->post; //get post content
    $id = $post->ID; //get post id
    $postlink = get_permalink($id); //get post link
    $title = trim(urlencode($post->post_title)); // get post title
    $link = split(DD_DASH,$postlink); //split the link with '#', for comment
				
    $dd_twitter = new DD_Twitter();
    $dd_twitter->construstURL($link[0],$source,$buttonDesign,$id,$service,$serviceapi);
    
	echo $dd_twitter->finalURL;
}


/**
 * Generate Topsy button link
 * @param $buttonDesign big or compact
 * @param $source tweetmeme source, username
 * @param $source twitter username
 * @param $serviceapi API Key for URL shorten service
 * @return Twitter button link
 */
function digg_digg_topsy_generate($buttonDesign='big', $source='', $theme='blue'){
	
	global $wp_query; 
    $post = $wp_query->post; //get post content
    $id = $post->ID; //get post id
    $postlink = get_permalink($id); //get post link
    $title = trim(urlencode($post->post_title)); // get post title
    $link = split(DD_DASH,$postlink); //split the link with '#', for comment
				
    $dd_topsy = new DD_Topsy();
    $dd_topsy->construstURL($link[0],$buttonDesign,$source, $theme);
    
	echo $dd_topsy->finalURL;
}

/**
 * Generate Facebook button link
 * @param $buttonDesign Normal or Compact
 * @return Facebook button link
 */
function digg_digg_fbshare_generate($buttonDesign='Normal'){
	
	global $wp_query; 
    $post = $wp_query->post; //get post content
    $id = $post->ID; //get post id
    $postlink = get_permalink($id); //get post link
    $title = trim(urlencode($post->post_title)); // get post title
    $link = split(DD_DASH,$postlink); //split the link with '#', for comment
    
    $dd_fbshare = new DD_FbShare();
    $dd_fbshare->construstURL($link[0],$title,$buttonDesign,$id);
    
	echo $dd_fbshare->finalURL;
}


/**
 * Generate Facebook button Me link
 * @param $buttonDesign Normal or Compact
 * @return Facebook button link
 */
function digg_digg_fbshareme_generate($buttonDesign='Normal'){
	
	global $wp_query; 
    $post = $wp_query->post; //get post content
    $id = $post->ID; //get post id
    $postlink = get_permalink($id); //get post link
    $title = trim(urlencode($post->post_title)); // get post title
    $link = split(DD_DASH,$postlink); //split the link with '#', for comment
    
    $dd_fbshareme = new DD_FbShareMe();
    $dd_fbshareme->construstURL($link[0],$title,$buttonDesign,$id);
    
	echo $dd_fbshareme->finalURL;
}

/**
 * Generate Facebook like button link
 * @param $buttonDesign Like, Like + Text, Recommend, Recommend + Text
 * @return Facebook like button link
 */
function digg_digg_fblike_generate($buttonDesign='Like'){

	global $wp_query; 
    $post = $wp_query->post; //get post content
    $id = $post->ID; //get post id
    $postlink = get_permalink($id); //get post link
    $title = trim(urlencode($post->post_title)); // get post title
    $link = split(DD_DASH,$postlink); //split the link with '#', for comment
    
    $dd_fblike = new DD_FbLike();
    $dd_fblike->construstURL($link[0],$title,$buttonDesign,$id);
    
	echo $dd_fblike->finalURL;
}

/**
 * Generate Polladium button link
 * @param $buttonDesign Normal or Compact
 * @return Polladium button link
 */
function digg_digg_poll_generate($buttonDesign='Normal'){
	
	global $wp_query; 
    $post = $wp_query->post; //get post content
    $id = $post->ID; //get post id
    $postlink = get_permalink($id); //get post link
    $title = trim(urlencode($post->post_title)); // get post title
    $link = split(DD_DASH,$postlink); //split the link with '#', for comment
    
    $dd_polladium = new DD_Polladium();
    $dd_polladium->construstURL($link[0],$title,$buttonDesign,$id);
    
	echo $dd_polladium->finalURL;
}
	

/**
 * Generate StumbleUpon button link
 * @param $buttonDesign Normal or Compact
 * @return StumbleUpon button link
 */
function digg_digg_stumbleupon_generate($buttonDesign='Normal'){
	
	global $wp_query; 
    $post = $wp_query->post; //get post content
    $id = $post->ID; //get post id
    $postlink = get_permalink($id); //get post link
    $title = trim(urlencode($post->post_title)); // get post title
    $link = split(DD_DASH,$postlink); //split the link with '#', for comment
    
    $dd_stumbleupon = new DD_StumbleUpon();
    $dd_stumbleupon->construstURL($link[0],$title,$buttonDesign,$id);
    
	echo $dd_stumbleupon->finalURL;
}	

/**
 * Generate Delicious button link
 * @param $buttonDesign Normal or Compact
 * @return Delicious button link
 */
function digg_digg_delicious_generate($buttonDesign='Normal'){
	
	global $wp_query; 
    $post = $wp_query->post; //get post content
    $id = $post->ID; //get post id
    $postlink = get_permalink($id); //get post link
    $title = trim(urlencode($post->post_title)); // get post title
    $link = split(DD_DASH,$postlink); //split the link with '#', for comment
    
    $dd_delicious = new DD_Delicious();
    $dd_delicious->construstURL($link[0],$title,$buttonDesign,$id);
    
	echo $dd_delicious->finalURL;
}	


/**
 * Generate Sphinn button link
 * @param $buttonDesign Normal or Compact
 * @return Sphinn button link
 */
function digg_digg_sphinn_generate($buttonDesign='Normal'){
	
	global $wp_query; 
    $post = $wp_query->post; //get post content
    $id = $post->ID; //get post id
    $postlink = get_permalink($id); //get post link
    $title = trim(urlencode($post->post_title)); // get post title
    $link = split(DD_DASH,$postlink); //split the link with '#', for comment
    
    $dd_sphinn = new DD_Sphinn();
    $dd_sphinn->construstURL($link[0],$title,$buttonDesign,$id);
    
	echo $dd_sphinn->finalURL;
}	


/**
 * Generate post comments button link
 * @param $buttonDesign Normal or Compact
 * @return Post comments button link
 */
function digg_digg_post_comments_generate(){
	
	global $wp_query; 
    $post = $wp_query->post; //get post content
    $id = $post->ID; //get post id
    $comments = $post->comment_count; //get post comments
    $postlink = get_permalink($id); //get post link
    $link = split(DD_DASH,$postlink); //split the link with '#', for comment
    
    $dd_comments = new DD_Comments();
    $dd_comments->construstURL($link[0],$comments);
    
	echo $dd_comments->finalURL;
}	

/**
 * Generate Google Buzz button link
 * @param $buttonDesign Normal or Compact
 * @return GBuzz button link
 */
function digg_digg_gbuzz_generate($buttonDesign='Normal'){
	
	global $wp_query; 
    $post = $wp_query->post; //get post content
    $id = $post->ID; //get post id
    $postlink = get_permalink($id); //get post link
    $title = trim(urlencode($post->post_title)); // get post title
    $link = split(DD_DASH,$postlink); //split the link with '#', for comment
    
    $dd_gbuzz = new DD_GBuzz();
    $dd_gbuzz->construstURL($link[0],$title,$buttonDesign,$id);
    
	echo $dd_gbuzz->finalURL;
}

/**
 * Generate Designbump link
 * @param $buttonDesign Normal or Compact
 * @return DesignBump button link
 */
function digg_digg_designbump_generate($buttonDesign='Normal'){
	
	global $wp_query; 
    $post = $wp_query->post; //get post content
    $id = $post->ID; //get post id
    $postlink = get_permalink($id); //get post link
    $title = trim(urlencode($post->post_title)); // get post title
    $link = split(DD_DASH,$postlink); //split the link with '#', for comment
    
    $dd_designbump = new DD_DesignBump();
    $dd_designbump->construstURL($link[0],$title,$buttonDesign,$id);
    
	echo $dd_designbump->finalURL;
}	

/**
 * Generate Designfloat link
 * @param $buttonDesign Normal or Compact
 * @return Designfloat button link
 */
function digg_digg_designfloat_generate($buttonDesign='Normal'){
	
	global $wp_query; 
    $post = $wp_query->post; //get post content
    $id = $post->ID; //get post id
    $postlink = get_permalink($id); //get post link
    $title = trim(urlencode($post->post_title)); // get post title
    $link = split(DD_DASH,$postlink); //split the link with '#', for comment
    
    $dd_designfloat = new DD_DesignFloat();
    $dd_designfloat->construstURL($link[0],$title,$buttonDesign,$id);
    
	echo $dd_designfloat->finalURL;
}	

/**
 * Generate WebBlend link
 * @param $buttonDesign Normal or Compact
 * @return WebBlend button link
 */
function digg_digg_webblend_generate($buttonDesign='Normal'){
	
	global $wp_query; 
    $post = $wp_query->post; //get post content
    $id = $post->ID; //get post id
    $postlink = get_permalink($id); //get post link
    $title = trim(urlencode($post->post_title)); // get post title
    $link = split(DD_DASH,$postlink); //split the link with '#', for comment
    
    $dd_webblend = new DD_WebBlend();
    $dd_webblend->construstURL($link[0],$title,$buttonDesign,$id);
    
	echo $dd_webblend->finalURL;
}	


/**
 * Generate BlogEngage link
 * @param $buttonDesign Normal or Compact
 * @return BlogEngagee button link
 */
function digg_digg_blogengage_generate($buttonDesign='Normal'){
	
	global $wp_query; 
    $post = $wp_query->post; //get post content
    $id = $post->ID; //get post id
    $postlink = get_permalink($id); //get post link
    $title = trim(urlencode($post->post_title)); // get post title
    $link = split(DD_DASH,$postlink); //split the link with '#', for comment
    
    $dd_blogengage = new DD_BlogEngage();
    $dd_blogengage->construstURL($link[0],$title,$buttonDesign,$id);
    
	echo $dd_blogengage->finalURL;
}	

?>